/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package ORM;

import ORM.MODEL.Actor;
import ORM.MODEL.Cast;
import ORM.MODEL.Movie;
import com.j256.ormlite.dao.CloseableWrappedIterable;
import com.j256.ormlite.dao.Dao;
import com.j256.ormlite.dao.DaoManager;
import com.j256.ormlite.dao.GenericRawResults;
import com.j256.ormlite.jdbc.JdbcConnectionSource;
import com.j256.ormlite.stmt.PreparedQuery;
import com.j256.ormlite.stmt.QueryBuilder;
import com.j256.ormlite.support.ConnectionSource;
import com.j256.ormlite.table.TableUtils;
import java.awt.List;
import java.util.ArrayList;

/**
 *
 * @author mw
 */
public class ORM {
    Dao<Actor, String> accountDao;

     public static void main(String[] args) throws Exception {

        // this uses h2 by default but change to match your database
        String databaseUrl = "jdbc:jtds:sqlserver://mssql.wmi.amu.edu.pl/DBADLI0_1CD";
        // create a connection source to our database
        ConnectionSource connectionSource =
            new JdbcConnectionSource(databaseUrl);

        // instantiate the dao <TableName / ID type>
        Dao<Actor, Integer> actorDao =
            DaoManager.createDao(connectionSource, Actor.class);

        // Jeżeli chcielibyśmy stworzyć tabele na podstawie Actor.class
        //TableUtils.createTable(connectionSource, Actor.class);

        // create an instance of Account
        Actor actor = new Actor();
        actor.setId(1);
        actor.setFname("AAA");
        actor.setLname("BBB");
        actor.setGender('F');
        
        Actor actor2 = actorDao.queryForId(1);
        actorDao.delete(actor);
        actor2 = actorDao.queryForId(0);
        actorDao.delete(actor2);
        
        // persist the account object to the database
        actorDao.create(actor);

        // retrieve the account from the database by its id field (name)
        actor2 = actorDao.queryForId(1);
        System.out.println("Actor: " + actor2.getFname() + " " + actor2.getLname());
        
        actor2.setFname("CCC");
        actorDao.update(actor2);
        
        actor2 = actorDao.queryForId(1);
        System.out.println("Actor: " + actor2.getFname() + " " + actor2.getLname());
        
        actor2.setFname("DDD");
        actorDao.refresh(actor2);
        System.out.println("Actor: " + actor2.getFname() + " " + actor2.getLname());
        
        //iterating through the table
        int index = 0;
        CloseableWrappedIterable<Actor> wrappedIterable = actorDao.getWrappedIterable();
        try {
            for (Actor actor3 : wrappedIterable) {
                System.out.println(actor3.getFname());
                index++;
                if (index>10) break;
        }
        } finally {
            wrappedIterable.close();
        }
        
        //RAW query
        // find out how many orders account-id #10 has
        GenericRawResults<String[]> rawResults = actorDao.queryRaw(
            "select * from actor where fname like '%SKI'");
        ArrayList<String[]> results = (ArrayList<String[]>) rawResults.getResults();
        for(String[] result :results) {
            //System.out.println(result[0] + " " + result[1] + " " + result[2]);
        }
        rawResults.close();
           
        //query single_value
        long actorsNB = actorDao.queryRawValue("select count(*) from actor");
        System.out.println(actorsNB);
        
        ArrayList<Actor> lista = (ArrayList<Actor>) actorDao.queryBuilder().where().eq("lname", "Linda").query();
        for(Actor a : lista){
            //System.out.println(a.getLname());
        }
        
        //select arguments like prepared statement sql injection

        Dao<Movie, Integer> movieDao =
            DaoManager.createDao(connectionSource, Movie.class);
        Dao<Cast, Integer> castDao =
            DaoManager.createDao(connectionSource, Cast.class);       
        // close the connection source
        connectionSource.close();
    }
}

