package PrepareStatement;

//STEP 1. Import required packages
import Indeks.*;
import java.sql.*;
import java.util.ArrayList;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.*;
import javax.swing.event.*;

public class SqlConnection {
    // JDBC driver name and database URL

    static final String JDBC_DRIVER = "net.sourceforge.jtds.jdbc.Driver";
    static final String DB_URL = "jdbc:jtds:sqlserver://mssql.wmi.amu.edu.pl/DBADLI0_1CD";

    public ArrayList<String> zapytanie(String nasze, int pr) {
        Connection conn = null;
        long startTime = 0;
        ResultSet rs = null;
        ArrayList list = new ArrayList<String>();
        Statement stmt = null;
        PreparedStatement pstmt= null;
        try {
            //STEP 2: Register JDBC driver
            Class.forName("net.sourceforge.jtds.jdbc.Driver");

            //STEP 3: Open a connection
            System.out.println("Connecting to database...");
            conn = DriverManager.getConnection(DB_URL);

            //STEP 4: Execute a query
            if (pr == 0) {                
                System.out.println("Creating statement...");
                stmt = conn.createStatement();
                String sql;
                sql = "select * from ACTOR where lname like " + nasze;
                startTime = System.currentTimeMillis();
                rs = stmt.executeQuery(sql);
            } else {                
                String sql;
                sql = "select * from ACTOR where lname like ?";
                pstmt = conn.prepareStatement(sql);
                pstmt.setString(1, nasze);
                startTime = System.currentTimeMillis();
                
                rs = pstmt.executeQuery();
            }           

            int index = 0;

            long estimatedTime = System.currentTimeMillis() - startTime;

            System.out.println("Czas trwania zapytania " + estimatedTime);

            ResultSetMetaData rsmd = rs.getMetaData();
            int columnCount = rsmd.getColumnCount();
            String kolumny = new String();
            // The column count starts from 1
            for (int i = 1; i <= columnCount; i++) {
                kolumny += rsmd.getColumnName(i);
                kolumny += " ";
            }

            list.add(kolumny);

            while (rs.next()) {
                String nowy = new String();
                for (int i = 1; i <= columnCount; i++) {
                    nowy += rs.getString(i);
                    nowy += " ";
                }
                list.add(nowy);

            }

            //STEP 6: Clean-up environment
            rs.close();
            if (pr==0)
            stmt.close();
            else
            pstmt.close();
            conn.close();
        } catch (SQLException se) {
            //Handle errors for JDBC
            se.printStackTrace();
        } catch (Exception e) {
            //Handle errors for Class.forName
            e.printStackTrace();
        } finally {
            //finally block used to close resources
            try {
                if (stmt != null) {
                    stmt.close();
                }
            } catch (SQLException se2) {
            }// nothing we can do
            try {
                if (conn != null) {
                    conn.close();
                }
            } catch (SQLException se) {
                se.printStackTrace();
            }//end finally try
        }//end try
        System.out.println("Goodbye!");
        return list;
    }

}//end FirstExample
